unit MyExcelAutomationAddin1_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, adxAddIn,
  MyExcelAutomationAddin1_TLB, StdVcl, Excel2000;

type
  TcoMyExcelAutomationAddin1 = class(TadxAddin, IcoMyExcelAutomationAddin1)
  protected
    function MyFunc(var Range: OleVariant): OleVariant; safecall;
  end;

  TAddInModule = class(TadxCOMAddInModule)
  private
  protected
  public
  end;

implementation

{$R *.dfm}

function TcoMyExcelAutomationAddin1.MyFunc(var Range: OleVariant): OleVariant;
begin
  Result := 0;
  case VarType(Range) of
    varSmallint, varInteger, varSingle,
    varDouble, varCurrency, varShortInt, varByte,
    varWord, varLongWord, varInt64: Result := Range * 1000;
  else
    try
      Result := Range.Cells[1, 1].Value * 1000;
    except
      Result := CVErr(xlErrValue);
    end;
  end;
end;

initialization
  TadxFactory.Create(ComServer, TcoMyExcelAutomationAddin1, CLASS_coMyExcelAutomationAddin1, TAddInModule);

end.
